Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.flagstone.transform
Class FSDefineButton

    java.lang.Object
      com.flagstone.transform.FSTransformObject
          com.flagstone.transform.FSMovieObject
              com.flagstone.transform.FSDefineObject
                  com.flagstone.transform.FSDefineButton

All Implemented Interfaces:
  java.lang.Cloneable

    public class FSDefineButton

extends FSDefineObject

FSDefineButton defines the appearance of a button and the actions performed when the button is clicked.

Attributes
type | Identifies the action when it is encoded. Read-only.
identifier | An unique identifier for this object, in the range 1..65535.
buttonRecords | an array of FSButton objects that define the appearance of the button in each of its states. The array must contain at least one FSButton object.
actions | an array of action objects that are executed when the button is clicked.
encodedActions | An array of bytes containing encoded actions can also be set. The encoded actions are typically generated by the parser in the Translate framework. The actions array and encodedActions cannot both be valid at the same time. Accessor methods used to set either of the attributes will set the other to null.

A FSDefineButton object must contain at least one FSButton object. If more than one button record is defined for a given button state then each shape will be displayed by the button. The order in which the shapes are displayed is determined by the layer assigned to each FSButton object.

# Examples

1. Define a simple button that highlights itself when the mouse is move over it. No actions are performed when the button is clicked.

     FSDefineShape normal = new FSDefineShape(movie.newIdentifier(), bounds,
                                    lineStyles, fillStyles, shape);
     FSDefineShape highlight = new FSDefineShape(movie.newIdentifier(), bounds,
                                    lineStyles, fillStyles, highlightShape);

     ArrayList records = new ArrayList();
     ArrayList actions = new ArrayList();

     records.add(new FSButton(FSButton.Up, normal.getIdentifier(), 1));
     records.add(new FSButton(FSButton.Over, highlight.getIdentifier(), 2));

     FSDefineButton button = new FSDefineButton(movie.newIdentifier(), records,
                                    actions);

2. Define a "complex" button that highlights itself when the mouse is move over it and actions are executed when the button is clicked.

     FSDefineShape upShape = new FSDefineShape(movie.newIdentifier(), bounds,
                                    lineStyles, fillStyles, shape1);
     FSDefineShape overShape = new FSDefineShape(movie.newIdentifier(), bounds,
                                    lineStyles, fillStyles, shape2);
     FSDefineShape downShape = new FSDefineShape(movie.newIdentifier(), bounds,
                                    lineStyles, fillStyles, shape3);

     ArrayList records = new ArrayList();
     records.add(new FSButton(FSButton.Up, upShape.getIdentifier(), 1));
     records.add(new FSButton(FSButton.Over, overShape.getIdentifier(), 2));
     records.add(new FSButton(FSButton.Down, downShape.getIdentifier(), 3));

     ArrayList actions = new ArrayList();

     actions.add(action);
     actions.add(action);
     actions.add(action);

     FSDefineButton button = new FSDefineButton(movie.newIdentifier(), records,
                                    actions);

3. If more than one button record is defined for a state then the layer number defines the order the shapes are displayed. This allows buttons to be "reused" with only the label on the button being changed.

     FSDefineShape upShape = new FSDefineShape(movie.newIdentifier(), bounds,
                                    lineStyles, fillStyles, shape1);
     FSDefineShape overShape = new FSDefineShape(movie.newIdentifier(), bounds,
                                    lineStyles, fillStyles, shape2);
     FSDefineShape downShape = new FSDefineShape(movie.newIdentifier(), bounds,
                                    lineStyles, fillStyles, shape3);

     // The label shape contains the "text" for the button. Note the text must be
     // drawn as a shape.

     FSDefineShape label = new FSDefineShape(movie.newIdentifier(), bounds,
                                    lineStyles, fillStyles, shape4);

     ArrayList records = new ArrayList();

     // Note that the label defined for all of the button's states. This ensures the
     // label is visible at all times when the mouse is moved over the button.

     records.add(FSButton(FSButton.Up, upShape.getIdentifier(), 1));
     records.add(FSButton(FSButton.Up, label.getIdentifier(), 2));
     records.add(FSButton(FSButton.Over, overShape.getIdentifier(), 3));
     records.add(FSButton(FSButton.Over, label.getIdentifier(), 4));
     records.add(FSButton(FSButton.Down, downShape.getIdentifier(), 5));
     records.add(FSButton(FSButton.Down, label.getIdentifier(), 6));

     ArrayList actions = new ArrayList();

     actions.add(action);
     actions.add(action);
     actions.add(action);

     FSDefineButton button = new FSDefineButton(movie.newIdentifier(), records,
                                    actions);

# History

The FSDefineButton class represents the DefineButton structure from the Macromedia Flash (SWF) File Format Specification. It was introduced in Flash 1.

Field Summary

Fields inherited from class com.flagstone.transform.FSDefineObject
`identifier`

Fields inherited from class com.flagstone.transform.FSMovieObject
`ButtonColorTransform, ButtonSound, DefineBitsPtr, DefineButton, DefineButton2, DefineFont, DefineFont2, DefineImage, DefineImage2, DefineJPEGImage, DefineJPEGImage2, DefineJPEGImage3, DefineMorphShape, DefineMovieClip, DefineShape, DefineShape2, DefineShape3, DefineSound, DefineText, DefineText2, DefineTextField, DefineVideo, DoAction, EnableDebugger, EnableDebugger2, Export, extendLength, FontInfo, FontInfo2, FrameLabel, Free, Import, Initialize, JPEGTables, length, LimitScript, PathsArePostscript, PlaceObject, PlaceObject2, Protect, QuicktimeMovie, RemoveObject, RemoveObject2, SerialNumber, SetBackgroundColor, ShowFrame, SoundStreamBlock, SoundStreamHead, SoundStreamHead2, StartSound, TabOrder, type, VideoFrame`

Constructor Summary
`FSDefineButton(FSCoder coder)` Construct an FSDefineButton object, initialising it with values decoded from an encoded object.
`FSDefineButton(FSDefineButton obj)` Constructs an FSDefineButton object by copying values from an existing object.
`FSDefineButton(int anIdentifier, java.util.ArrayList buttonRecordArray, java.util.ArrayList actionArray)` Constructs an FSDefineButton object with the identifier, button records and actions.
`FSDefineButton(int anIdentifier, java.util.ArrayList buttonRecordArray, byte[] bytes)` Constructs an FSDefineButton object with the identifier, button records and encoded actions.

Method Summary
`void` | `add(FSActionObject anAction)` Adds the action object to the array of actions.
`void` | `add(FSButton aButtonRecord)` Adds the button record object to the array of button records.
`void` | `appendDescription(java.lang.StringBuffer buffer, int depth)` AppendDescription is used to present a string description of the object including all nested objects up to a specified depth.
`java.lang.Object` | `clone()` Creates a deep copy of the entire object.
`void` | `decode(FSCoder coder)`
`void` | `encode(FSCoder coder)`
`boolean` | `equals(java.lang.Object anObject)` Returns true if anObject is equal to this one.
`java.util.ArrayList` | `getActions()` Gets the array of actions that will be executed when the button is clicked and released.
`java.util.ArrayList` | `getButtonRecords()` Gets the array of button records defined for this button.
`byte[]` | `getEncodedActions()` Get the array of encoded actions that are executed when the frame is displayed.
`int` | `length(FSCoder coder)`
`void` | `setActions(java.util.ArrayList anArray)` Sets the array of actions that will be executed when the button is clicked and released.
`void` | `setButtonRecords(java.util.ArrayList anArray)` Sets the array of button records defined for this button.
`void` | `setEncodedActions(byte[] bytes)` Set the array of encoded actions that will be executed when the button is clicked and released.

Methods inherited from class com.flagstone.transform.FSDefineObject
`getIdentifier, setIdentifier`

Methods inherited from class com.flagstone.transform.FSMovieObject
`getType`

Methods inherited from class com.flagstone.transform.FSTransformObject
`name, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FSDefineButton

    public FSDefineButton(FSCoder coder)

  Construct an FSDefineButton object, initialising it with values decoded from an encoded object.

  Parameters:
    `coder` - an FSCoder containing the binary data.

### FSDefineButton

    public FSDefineButton(int anIdentifier,
                          java.util.ArrayList buttonRecordArray,
                          java.util.ArrayList actionArray)

  Constructs an FSDefineButton object with the identifier, button records and actions.

  Parameters:
    `anIdentifier` - a unique identifier for this button.
    `buttonRecordArray` - an array of FSButton objects.
    `actionArray` - and array of action objects.

### FSDefineButton

    public FSDefineButton(FSDefineButton obj)

  Constructs an FSDefineButton object by copying values from an existing object.

  Parameters:
    `obj` - an FSDefineButton object.

### FSDefineButton

    public FSDefineButton(int anIdentifier,
                          java.util.ArrayList buttonRecordArray,
                          byte[] bytes)

  Constructs an FSDefineButton object with the identifier, button records and encoded actions.

  Parameters:
    `anIdentifier` - a unique identifier for this button.
    `buttonRecordArray` - an array of FSButton objects.
    `bytes` - an array of encoded action objects.

Method Detail

### add

    public void add(FSButton aButtonRecord)

  Adds the button record object to the array of button records.

  Parameters:
    `aButtonRecord` - an FSButton object.

### add

    public void add(FSActionObject anAction)

  Adds the action object to the array of actions.

  Parameters:
    `anAction` - an object belonging to a class derived from FSActionObject.

### getButtonRecords

    public java.util.ArrayList getButtonRecords()

  Gets the array of button records defined for this button.

  Returns:
    the array of FSButton objects defined for this button.

### getActions

    public java.util.ArrayList getActions()

  Gets the array of actions that will be executed when the button is clicked and released.

  Returns:
    the array of action objects defined for this button.

### setButtonRecords

    public void setButtonRecords(java.util.ArrayList anArray)

  Sets the array of button records defined for this button.

  Parameters:
    `anArray` - an array of FSButton objects.

### setActions

    public void setActions(java.util.ArrayList anArray)

  Sets the array of actions that will be executed when the button is clicked and released.

  Parameters:
    `anArray` - and array of action objects.

### getEncodedActions

    public byte[] getEncodedActions()

  Get the array of encoded actions that are executed when the frame is displayed.

  Returns:
    the array of action objects or null if the actions have been decoded.

### setEncodedActions

    public void setEncodedActions(byte[] bytes)

  Set the array of encoded actions that will be executed when the button is clicked and released. The encoded actions are typically generated by the classes in the Translate framework. If the object already contains an array of actions then they will be deleted.

  Parameters:
    `bytes` - the array of encoded actions.

### clone

    public java.lang.Object clone()

  Description copied from class: `FSTransformObject`
  Creates a deep copy of the entire object.

  Overrides:
    `clone` in class `FSTransformObject`
  Returns:
    a copy of the object.

### equals

    public boolean equals(java.lang.Object anObject)

  Description copied from class: `FSMovieObject`
  Returns true if anObject is equal to this one. Objects are considered equal if they would generate identical binary data when they are encoded to a Flash file.

  Overrides:
    `equals` in class `FSMovieObject`
  Returns:
    true if this object would be identical to anObject when encoded.

### appendDescription

    public void appendDescription(java.lang.StringBuffer buffer,
                                  int depth)

  Description copied from class: `FSTransformObject`
  AppendDescription is used to present a string description of the object including all nested objects up to a specified depth. This method provide a more controlled way of creating a string representation of an object since large objects such as font or shape definitions can contain dozens of nested objects. The representation of the object is appended to the StringBuffer, showing the name of the class and values of the attributes it contains. If the object contains any attributes that are objects then the object graph will be traversed up to the specified depth. If objects are nested at a level less than specified depth then the full string representation of the object is displayed. For objects at the specified depth only the name of the class is displayed. Any objects below this depth are not displayed.

  Overrides:
    `appendDescription` in class `FSDefineObject`
  Parameters:
    `buffer` - a StringBuffer to which the description of each object is appended.
    `depth` - the maximum level of nesting up to which objects will be displayed.

### length

    public int length(FSCoder coder)

  Overrides:
    `length` in class `FSDefineObject`

### encode

    public void encode(FSCoder coder)

  Overrides:
    `encode` in class `FSDefineObject`

### decode

    public void decode(FSCoder coder)

  Overrides:
    `decode` in class `FSDefineObject`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD